﻿using System;
using System.ServiceProcess;
using System.Text;
using System.Net.Sockets;
using System.Net;
using System.IO;
using System.Xml.Linq;
using System.Xml;

namespace Ips_Get_Tcp_Stream
{
    static class Program
    {
        //// Values for coordinate transformations

        ////Longitude 10.5 to NTM Zone 10 Eastings = 100km
        //public const double ntmEastingsOffset = 100000.0;

        ////Length in meters from Latitude 63.0 to 64.0 
        //public const double lengthOfADegreeOfLatitude64 = 48932.0;

        ////Length in meters from Latitude 62.0 to 63.0 
        //public const double lengthOfADegreeOfLatitude63 = 50676.0;

        ////Latitude 58.0 to NTM Zone 10 Eastings = 1000km
        //public const double ntmNorthingsOffset = 1000000.0;

        //////Length in meters from Latitude 58 to 63
        //public const double ntmNorthingsFor63DegreesNorth = 557136.54446237876;

        //////Length in meters from Latitude 58 to 64
        //public const double ntmNorthingsFor64DegreesNorth = 668530.11935991876;

        //public const double latitudeLowerBound = 63.0;
        //public const double longitudeLowerBound = 10.0;

        static void Main()
        {
            ServiceBase[] ServicesToRun;
            ServicesToRun = new ServiceBase[]
            {
                new Ips_Get_Tcp_Stream()
            };
            ServiceBase.Run(ServicesToRun);
        }


        //Method to get current IP of the server this service is running on.
        public static string getIP()
        {
            try
            {
                //First get the name of the machine.
                string hostName = Dns.GetHostName();

                // Then get the IP, by using the machine name.
                string IP = Dns.GetHostByName(hostName).AddressList[0].ToString();

                return IP;
            }
            catch
            {
                File.AppendAllText(@"F:\Database\Database1119_4010\TrackingData\LogFiles\errorlog.txt", DateTime.Now.ToString("yyyyMMddHHmm") + " - Error: Failed to retrieve local IP, trying 10.253.42.24 instead." + Environment.NewLine);
                return "10.253.42.24";
            }
        }

        ////*********ADDITIONAL METHODS USED UNDER DEVELOPMENT*********************

        ////Validates that the xml files has proper ending
        //public static bool validateXML(string file)
        //{            
        //    try
        //    {
        //        XmlTextReader reader;
        //        reader = new XmlTextReader(file);
        //        while (reader.Read())
        //        {
        //            if (reader.NodeType == XmlNodeType.EndElement)
        //            {
        //                return true;
        //            }
        //        }
        //        return false;                         
        //    }
        //    catch
        //    {
        //        File.AppendAllText(@"F:\Database\Database1119_4010\TrackingData\LogFiles\errorlog.txt", DateTime.Now.ToString("yyyyMMddHHmm") + " - Error: failed to decode tag messages. File: " + file + Environment.NewLine);
        //        return false;
        //    }
        //}

        ////This method filters the xml, removing wirelessclients, leaving just tags
        //public static void sortOutTags(string file)
        //{
        //    XElement xelem = XElement.Load(file);
        //    File.Delete(file);
        //    xelem.DescendantsAndSelf("WirelessClientLocation").Remove();
        //    xelem.Save(file);
        //}

        ////Removes VendorData
        //public static void removeVendorData(string file)
        //{
        //    XElement xelem = XElement.Load(file);
        //    File.Delete(file);
        //    xelem.DescendantsAndSelf("VendorData").Remove();
        //    xelem.Save(file);
        //}

        ////This method decodes the messages on the tags.
        //public static void decodeMessages(string file, string output)
        //{
        //    try
        //    {
        //        XmlDocument xml = new XmlDocument();
        //        xml.Load(file);
        //        XmlNodeList xnl = xml.SelectNodes("/StreamingNotification/TagLocation/VendorData");

        //        //Loops through all messages and decodes them.
        //        foreach (XmlNode xn in xnl)
        //        {
        //            byte[] encodedMessage = Convert.FromBase64String(xn.Attributes["data"].Value);
        //            string decodedMessage = Encoding.UTF8.GetString(encodedMessage);
        //            string cleanstring = decodedMessage.Remove(0, 10);

        //            // remove 10 for 5 character long strings
        //            // seems to be the same for 10 character long strings
        //            //might be based on odd or even numbers
        //            //SE001 (5 char)
        //            //24121se001 (10 char)

        //            //moving-object (13 char)
        //            //testetaggteste (14 char)

        //            xn.Attributes["data"].Value = cleanstring;
        //        }
        //        //File.Delete(file);
        //        xml.Save(output);
        //    }
        //    catch
        //    {
        //        File.AppendAllText(@"F:\Database\Database1119_4010\TrackingData\LogFiles\errorlog.txt", DateTime.Now.ToString("yyyyMMddHHmm") + " - Error: failed to decode tag messages. File: " + file + Environment.NewLine);
        //    }
        //}

        ////Converts geo coordinates (WGS84) to local BIM coordinates.
        //public static void processCoordinates(string file)
        //{
        //    try
        //    {
        //        XmlDocument xml = new XmlDocument();
        //        xml.Load(file);
        //        XmlNodeList xnl = xml.SelectNodes("/StreamingNotification/TagLocation/GeoCoordinate");

        //        foreach (XmlNode xn in xnl)
        //        {
        //            double GeoLat = double.Parse(xn.Attributes["lattitude"].Value, System.Globalization.CultureInfo.InvariantCulture);
        //            double GeoLong = double.Parse(xn.Attributes["longitude"].Value, System.Globalization.CultureInfo.InvariantCulture);

        //            xn.Attributes["lattitude"].Value = Convert.ToString(NtmToBim(DegreesToNtm(new Point2D(GeoLong, GeoLat))).y);

        //            xn.Attributes["longitude"].Value = Convert.ToString(NtmToBim(DegreesToNtm(new Point2D(GeoLong, GeoLat))).x);
        //        }
        //        File.Delete(file);
        //        xml.Save(file);
        //    }
        //    catch
        //    {
        //        File.AppendAllText(@"F:\Database\Database1119_4010\TrackingData\LogFiles\errorlog.txt", DateTime.Now.ToString("yyyyMMddHHmm") + " - Error: failed to process coordinates." + Environment.NewLine);
        //    }
        //}

        ////Class for coordinates

        //public class Point2D : object
        //{
        //    public double x, y;
        //    public Point2D(double x, double y)
        //    {
        //        this.x = x;
        //        this.y = y;
        //    }

        //    //Interpolation Method
        //    public static double Lerp(double a, double b, double w)
        //    {
        //        return (1.0 - w) * a + w * b;
        //    }
        //}

        ////Converts coordinates from WGS84 to NTM zone 10
        //public static Point2D DegreesToNtm(Point2D degrees)
        //{
        //    try
        //    {
        //        Point2D coordinates = new Point2D(degrees.x, degrees.y);

        //        //Interpolate between Longtitude 63 and 64, and convert x coordinate to NTM zone 10
        //        coordinates.x = Point2D.Lerp(
        //        ntmEastingsOffset - Point2D.Lerp(lengthOfADegreeOfLatitude63, lengthOfADegreeOfLatitude64, degrees.y - latitudeLowerBound) / 2.0,
        //        ntmEastingsOffset + Point2D.Lerp(lengthOfADegreeOfLatitude63, lengthOfADegreeOfLatitude64, degrees.y - latitudeLowerBound) / 2.0,
        //        degrees.x - longitudeLowerBound);

        //        //Interpolate between Longtitude 63 and 64, and convert y coordinate to NTM zone 10
        //        coordinates.y = Point2D.Lerp(
        //        ntmNorthingsOffset + ntmNorthingsFor63DegreesNorth,
        //        ntmNorthingsOffset + ntmNorthingsFor64DegreesNorth,
        //        degrees.y - latitudeLowerBound);

        //        return coordinates;
        //    }
        //    catch
        //    {
        //        File.AppendAllText(@"F:\Database\Database1119_4010\TrackingData\LogFiles\errorlog.txt", DateTime.Now.ToString("yyyyMMddHHmm") + " - Error: failed to convert coordinates from WGS84 to NTM zone 10." + Environment.NewLine);
        //        return null;
        //    }
        //}

        ////Converts coordinates from NTM zone 10 to local BIM coordinates
        //public static Point2D NtmToBim(Point2D ntmCoordinates)
        //{
        //    try
        //    {
        //        ////This if-loop checks which bulding the coordinate is in, and uses subtracts the buildings reference point from the coordinate
        //        //if (ntmCoordinates.y > 1604691.8155016776)
        //        //{
        //        //    //Coordinate is inside nevro when it is above Northing 1603988.11
        //        //ntmCoordinates.x -= 94851.220000;
        //        //    ntmCoordinates.y -= 1604694.800000;
        //        //}
        //        //else
        //        //{
        //        //    //Coordinate is inside KVB when y coordinate is south from nevro. (south of Northing 1603988.11)
        //        //ntmCoordinates.x -= 94852.995400;
        //        //    ntmCoordinates.y -= 1604691.815500;
        //        //}

        //        //Reference coordinates for Nevro.
        //        ntmCoordinates.x -= 94851.220000;
        //        ntmCoordinates.y -= 1604694.800000;
        //        //convert from meters to mm
        //        ntmCoordinates.x = ntmCoordinates.x * 1000;
        //        ntmCoordinates.y = ntmCoordinates.y * 1000;

        //        return ntmCoordinates;
        //    }
        //    catch
        //    {
        //        File.AppendAllText(@"F:\Database\Database1119_4010\TrackingData\LogFiles\errorlog.txt", DateTime.Now.ToString("yyyyMMddHHmm") + " - Error: failed to convert coordinates from zone 10 to local BIM coordinates." + Environment.NewLine);
        //        return null;
        //    }
           
        //}
    }
}


